// 1 "runtime/table.j"
// 1 "<built-in>"
// 1 "<command-line>"
// 1 "/usr/include/stdc-predef.h" 1 3 4
// 1 "<command-line>" 2
// 1 "runtime/table.j"



globals
// 1 "runtime/alloc-globals.j" 1

integer JHCR_Table_F = 0
integer array JHCR_Table_V
integer JHCR_Table_I = 0
// 6 "runtime/table.j" 2

    hashtable JHCR_Table_ht = InitHashtable()

    integer array JHCR_Table_list

    agent array JHCR_Table_agent
    buff array JHCR_Table_buff
    camerasetup array JHCR_Table_camerasetup
    conditionfunc array JHCR_Table_conditionfunc
    eventid array JHCR_Table_eventid
    filterfunc array JHCR_Table_filterfunc
    gamecache array JHCR_Table_gamecache
    gamestate array JHCR_Table_gamestate
    handle array JHCR_Table_handle
    terraindeformation array JHCR_Table_terraindeformation
    weathereffect array JHCR_Table_weathereffect


    minimapicon array JHCR_Table_minimapicon
    commandbuttoneffect array JHCR_Table_commandbuttoneffect


endglobals

// 1 "runtime/alloc.j" 1

function JHCR_Table_alloc takes nothing returns integer
    local integer JHCR_Table_this = JHCR_Table_F
    if JHCR_Table_this != 0 then
        set JHCR_Table_F = JHCR_Table_V[JHCR_Table_this]
    else
        set JHCR_Table_I = JHCR_Table_I+1
        set JHCR_Table_this = JHCR_Table_I
    endif

    if JHCR_Table_this >= JASS_MAX_ARRAY_SIZE then
        call JHCR_Print_print("no more free instances " + "JHCR_Table__BASE_FILE__")
        return 0
    endif

    set JHCR_Table_V[JHCR_Table_this] = -1
    return JHCR_Table_this
endfunction

function JHCR_Table_free takes integer JHCR_Table_this returns nothing
    if JHCR_Table_this == 0 then
        call JHCR_Print_print("free of nullptr " + "JHCR_Table__BASE_FILE__")
        return
    elseif JHCR_Table_V[JHCR_Table_this] != -1 then
        call JHCR_Print_print("Double free in " + "JHCR_Table__BASE_FILE__")
        return
    endif
    set JHCR_Table_V[JHCR_Table_this] = JHCR_Table_F
    set JHCR_Table_F = JHCR_Table_this
endfunction
// 31 "runtime/table.j" 2

function JHCR_Table_flush takes integer JHCR_Table_tbl returns nothing
    call JHCR_List_destroy(JHCR_Table_list[JHCR_Table_tbl])
    set JHCR_Table_list[JHCR_Table_tbl] = 0
    call FlushChildHashtable(JHCR_Table_ht, JHCR_Table_tbl)
endfunction

function JHCR_Table_destroy takes integer JHCR_Table_tbl returns nothing
    call JHCR_List_destroy(JHCR_Table_list[JHCR_Table_tbl])
    set JHCR_Table_list[JHCR_Table_tbl] = 0
    call FlushChildHashtable(JHCR_Table_ht, JHCR_Table_tbl)
    call JHCR_Table_free(JHCR_Table_tbl)
endfunction



function JHCR_Table_get_boolean takes integer JHCR_Table_this,integer JHCR_Table_key returns boolean
    return LoadBoolean(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_boolean takes integer JHCR_Table_this,integer JHCR_Table_key,boolean JHCR_Table_value returns nothing
    call SaveBoolean(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_integer takes integer JHCR_Table_this,integer JHCR_Table_key returns integer
    return LoadInteger(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_integer takes integer JHCR_Table_this,integer JHCR_Table_key,integer JHCR_Table_value returns nothing
    call SaveInteger(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_real takes integer JHCR_Table_this,integer JHCR_Table_key returns real
    return LoadReal(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_real takes integer JHCR_Table_this,integer JHCR_Table_key,real JHCR_Table_value returns nothing
    call SaveReal(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_string takes integer JHCR_Table_this,integer JHCR_Table_key returns string
    return LoadStr(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_string takes integer JHCR_Table_this,integer JHCR_Table_key,string JHCR_Table_value returns nothing
    call SaveStr(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction



function JHCR_Table_get_ability takes integer JHCR_Table_this,integer JHCR_Table_key returns ability
    return LoadAbilityHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_ability takes integer JHCR_Table_this,integer JHCR_Table_key,ability JHCR_Table_value returns nothing
    call SaveAbilityHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_boolexpr takes integer JHCR_Table_this,integer JHCR_Table_key returns boolexpr
    return LoadBooleanExprHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_boolexpr takes integer JHCR_Table_this,integer JHCR_Table_key,boolexpr JHCR_Table_value returns nothing
    call SaveBooleanExprHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_button takes integer JHCR_Table_this,integer JHCR_Table_key returns button
    return LoadButtonHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_button takes integer JHCR_Table_this,integer JHCR_Table_key,button JHCR_Table_value returns nothing
    call SaveButtonHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_defeatcondition takes integer JHCR_Table_this,integer JHCR_Table_key returns defeatcondition
    return LoadDefeatConditionHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_defeatcondition takes integer JHCR_Table_this,integer JHCR_Table_key,defeatcondition JHCR_Table_value returns nothing
    call SaveDefeatConditionHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_destructable takes integer JHCR_Table_this,integer JHCR_Table_key returns destructable
    return LoadDestructableHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_destructable takes integer JHCR_Table_this,integer JHCR_Table_key,destructable JHCR_Table_value returns nothing
    call SaveDestructableHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_dialog takes integer JHCR_Table_this,integer JHCR_Table_key returns dialog
    return LoadDialogHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_dialog takes integer JHCR_Table_this,integer JHCR_Table_key,dialog JHCR_Table_value returns nothing
    call SaveDialogHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_effect takes integer JHCR_Table_this,integer JHCR_Table_key returns effect
    return LoadEffectHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_effect takes integer JHCR_Table_this,integer JHCR_Table_key,effect JHCR_Table_value returns nothing
    call SaveEffectHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_fogmodifier takes integer JHCR_Table_this,integer JHCR_Table_key returns fogmodifier
    return LoadFogModifierHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_fogmodifier takes integer JHCR_Table_this,integer JHCR_Table_key,fogmodifier JHCR_Table_value returns nothing
    call SaveFogModifierHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_fogstate takes integer JHCR_Table_this,integer JHCR_Table_key returns fogstate
    return LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_fogstate takes integer JHCR_Table_this,integer JHCR_Table_key,fogstate JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_force takes integer JHCR_Table_this,integer JHCR_Table_key returns force
    return LoadForceHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_force takes integer JHCR_Table_this,integer JHCR_Table_key,force JHCR_Table_value returns nothing
    call SaveForceHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_group takes integer JHCR_Table_this,integer JHCR_Table_key returns group
    return LoadGroupHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_group takes integer JHCR_Table_this,integer JHCR_Table_key,group JHCR_Table_value returns nothing
    call SaveGroupHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_hashtable takes integer JHCR_Table_this,integer JHCR_Table_key returns hashtable
    return LoadHashtableHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_hashtable takes integer JHCR_Table_this,integer JHCR_Table_key,hashtable JHCR_Table_value returns nothing
    call SaveHashtableHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_image takes integer JHCR_Table_this,integer JHCR_Table_key returns image
    return LoadImageHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_image takes integer JHCR_Table_this,integer JHCR_Table_key,image JHCR_Table_value returns nothing
    call SaveImageHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_item takes integer JHCR_Table_this,integer JHCR_Table_key returns item
    return LoadItemHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_item takes integer JHCR_Table_this,integer JHCR_Table_key,item JHCR_Table_value returns nothing
    call SaveItemHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_itempool takes integer JHCR_Table_this,integer JHCR_Table_key returns itempool
    return LoadItemPoolHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_itempool takes integer JHCR_Table_this,integer JHCR_Table_key,itempool JHCR_Table_value returns nothing
    call SaveItemPoolHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_leaderboard takes integer JHCR_Table_this,integer JHCR_Table_key returns leaderboard
    return LoadLeaderboardHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_leaderboard takes integer JHCR_Table_this,integer JHCR_Table_key,leaderboard JHCR_Table_value returns nothing
    call SaveLeaderboardHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_lightning takes integer JHCR_Table_this,integer JHCR_Table_key returns lightning
    return LoadLightningHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_lightning takes integer JHCR_Table_this,integer JHCR_Table_key,lightning JHCR_Table_value returns nothing
    call SaveLightningHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_location takes integer JHCR_Table_this,integer JHCR_Table_key returns location
    return LoadLocationHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_location takes integer JHCR_Table_this,integer JHCR_Table_key,location JHCR_Table_value returns nothing
    call SaveLocationHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_multiboard takes integer JHCR_Table_this,integer JHCR_Table_key returns multiboard
    return LoadMultiboardHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_multiboard takes integer JHCR_Table_this,integer JHCR_Table_key,multiboard JHCR_Table_value returns nothing
    call SaveMultiboardHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_multiboarditem takes integer JHCR_Table_this,integer JHCR_Table_key returns multiboarditem
    return LoadMultiboardItemHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_multiboarditem takes integer JHCR_Table_this,integer JHCR_Table_key,multiboarditem JHCR_Table_value returns nothing
    call SaveMultiboardItemHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_player takes integer JHCR_Table_this,integer JHCR_Table_key returns player
    return LoadPlayerHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_player takes integer JHCR_Table_this,integer JHCR_Table_key,player JHCR_Table_value returns nothing
    call SavePlayerHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_quest takes integer JHCR_Table_this,integer JHCR_Table_key returns quest
    return LoadQuestHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_quest takes integer JHCR_Table_this,integer JHCR_Table_key,quest JHCR_Table_value returns nothing
    call SaveQuestHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_questitem takes integer JHCR_Table_this,integer JHCR_Table_key returns questitem
    return LoadQuestItemHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_questitem takes integer JHCR_Table_this,integer JHCR_Table_key,questitem JHCR_Table_value returns nothing
    call SaveQuestItemHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_rect takes integer JHCR_Table_this,integer JHCR_Table_key returns rect
    return LoadRectHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_rect takes integer JHCR_Table_this,integer JHCR_Table_key,rect JHCR_Table_value returns nothing
    call SaveRectHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_region takes integer JHCR_Table_this,integer JHCR_Table_key returns region
    return LoadRegionHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_region takes integer JHCR_Table_this,integer JHCR_Table_key,region JHCR_Table_value returns nothing
    call SaveRegionHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_sound takes integer JHCR_Table_this,integer JHCR_Table_key returns sound
    return LoadSoundHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_sound takes integer JHCR_Table_this,integer JHCR_Table_key,sound JHCR_Table_value returns nothing
    call SaveSoundHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_texttag takes integer JHCR_Table_this,integer JHCR_Table_key returns texttag
    return LoadTextTagHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_texttag takes integer JHCR_Table_this,integer JHCR_Table_key,texttag JHCR_Table_value returns nothing
    call SaveTextTagHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_timer takes integer JHCR_Table_this,integer JHCR_Table_key returns timer
    return LoadTimerHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_timer takes integer JHCR_Table_this,integer JHCR_Table_key,timer JHCR_Table_value returns nothing
    call SaveTimerHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_timerdialog takes integer JHCR_Table_this,integer JHCR_Table_key returns timerdialog
    return LoadTimerDialogHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_timerdialog takes integer JHCR_Table_this,integer JHCR_Table_key,timerdialog JHCR_Table_value returns nothing
    call SaveTimerDialogHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_trackable takes integer JHCR_Table_this,integer JHCR_Table_key returns trackable
    return LoadTrackableHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_trackable takes integer JHCR_Table_this,integer JHCR_Table_key,trackable JHCR_Table_value returns nothing
    call SaveTrackableHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_trigger takes integer JHCR_Table_this,integer JHCR_Table_key returns trigger
    return LoadTriggerHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_trigger takes integer JHCR_Table_this,integer JHCR_Table_key,trigger JHCR_Table_value returns nothing
    call SaveTriggerHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_triggeraction takes integer JHCR_Table_this,integer JHCR_Table_key returns triggeraction
    return LoadTriggerActionHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_triggeraction takes integer JHCR_Table_this,integer JHCR_Table_key,triggeraction JHCR_Table_value returns nothing
    call SaveTriggerActionHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_triggercondition takes integer JHCR_Table_this,integer JHCR_Table_key returns triggercondition
    return LoadTriggerConditionHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_triggercondition takes integer JHCR_Table_this,integer JHCR_Table_key,triggercondition JHCR_Table_value returns nothing
    call SaveTriggerConditionHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_event takes integer JHCR_Table_this,integer JHCR_Table_key returns event
    return LoadTriggerEventHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_event takes integer JHCR_Table_this,integer JHCR_Table_key,event JHCR_Table_value returns nothing
    call SaveTriggerEventHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_ubersplat takes integer JHCR_Table_this,integer JHCR_Table_key returns ubersplat
    return LoadUbersplatHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_ubersplat takes integer JHCR_Table_this,integer JHCR_Table_key,ubersplat JHCR_Table_value returns nothing
    call SaveUbersplatHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_unit takes integer JHCR_Table_this,integer JHCR_Table_key returns unit
    return LoadUnitHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_unit takes integer JHCR_Table_this,integer JHCR_Table_key,unit JHCR_Table_value returns nothing
    call SaveUnitHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_unitpool takes integer JHCR_Table_this,integer JHCR_Table_key returns unitpool
    return LoadUnitPoolHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_unitpool takes integer JHCR_Table_this,integer JHCR_Table_key,unitpool JHCR_Table_value returns nothing
    call SaveUnitPoolHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction


function JHCR_Table_get_widget takes integer JHCR_Table_this,integer JHCR_Table_key returns widget
    return LoadWidgetHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_widget takes integer JHCR_Table_this,integer JHCR_Table_key,widget JHCR_Table_value returns nothing
    call SaveWidgetHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction



function JHCR_Table_get_aidifficulty takes integer JHCR_Table_this,integer JHCR_Table_key returns aidifficulty
    return ConvertAIDifficulty(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_aidifficulty takes integer JHCR_Table_this,integer JHCR_Table_key,aidifficulty JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_alliancetype takes integer JHCR_Table_this,integer JHCR_Table_key returns alliancetype
    return ConvertAllianceType(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_alliancetype takes integer JHCR_Table_this,integer JHCR_Table_key,alliancetype JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction



function JHCR_Table_get_attacktype takes integer JHCR_Table_this,integer JHCR_Table_key returns attacktype
    return ConvertAttackType(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_attacktype takes integer JHCR_Table_this,integer JHCR_Table_key,attacktype JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_blendmode takes integer JHCR_Table_this,integer JHCR_Table_key returns blendmode
    return ConvertBlendMode(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_blendmode takes integer JHCR_Table_this,integer JHCR_Table_key,blendmode JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_camerafield takes integer JHCR_Table_this,integer JHCR_Table_key returns camerafield
    return ConvertCameraField(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_camerafield takes integer JHCR_Table_this,integer JHCR_Table_key,camerafield JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_damagetype takes integer JHCR_Table_this,integer JHCR_Table_key returns damagetype
    return ConvertDamageType(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_damagetype takes integer JHCR_Table_this,integer JHCR_Table_key,damagetype JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_dialogevent takes integer JHCR_Table_this,integer JHCR_Table_key returns dialogevent
    return ConvertDialogEvent(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_dialogevent takes integer JHCR_Table_this,integer JHCR_Table_key,dialogevent JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_effecttype takes integer JHCR_Table_this,integer JHCR_Table_key returns effecttype
    return ConvertEffectType(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_effecttype takes integer JHCR_Table_this,integer JHCR_Table_key,effecttype JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_fgamestate takes integer JHCR_Table_this,integer JHCR_Table_key returns fgamestate
    return ConvertFGameState(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_fgamestate takes integer JHCR_Table_this,integer JHCR_Table_key,fgamestate JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_gamedifficulty takes integer JHCR_Table_this,integer JHCR_Table_key returns gamedifficulty
    return ConvertGameDifficulty(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_gamedifficulty takes integer JHCR_Table_this,integer JHCR_Table_key,gamedifficulty JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_gameevent takes integer JHCR_Table_this,integer JHCR_Table_key returns gameevent
    return ConvertGameEvent(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_gameevent takes integer JHCR_Table_this,integer JHCR_Table_key,gameevent JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_gamespeed takes integer JHCR_Table_this,integer JHCR_Table_key returns gamespeed
    return ConvertGameSpeed(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_gamespeed takes integer JHCR_Table_this,integer JHCR_Table_key,gamespeed JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_gametype takes integer JHCR_Table_this,integer JHCR_Table_key returns gametype
    return ConvertGameType(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_gametype takes integer JHCR_Table_this,integer JHCR_Table_key,gametype JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_igamestate takes integer JHCR_Table_this,integer JHCR_Table_key returns igamestate
    return ConvertIGameState(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_igamestate takes integer JHCR_Table_this,integer JHCR_Table_key,igamestate JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_itemtype takes integer JHCR_Table_this,integer JHCR_Table_key returns itemtype
    return ConvertItemType(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_itemtype takes integer JHCR_Table_this,integer JHCR_Table_key,itemtype JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_limitop takes integer JHCR_Table_this,integer JHCR_Table_key returns limitop
    return ConvertLimitOp(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_limitop takes integer JHCR_Table_this,integer JHCR_Table_key,limitop JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_mapcontrol takes integer JHCR_Table_this,integer JHCR_Table_key returns mapcontrol
    return ConvertMapControl(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_mapcontrol takes integer JHCR_Table_this,integer JHCR_Table_key,mapcontrol JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_mapdensity takes integer JHCR_Table_this,integer JHCR_Table_key returns mapdensity
    return ConvertMapDensity(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_mapdensity takes integer JHCR_Table_this,integer JHCR_Table_key,mapdensity JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_mapflag takes integer JHCR_Table_this,integer JHCR_Table_key returns mapflag
    return ConvertMapFlag(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_mapflag takes integer JHCR_Table_this,integer JHCR_Table_key,mapflag JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_mapsetting takes integer JHCR_Table_this,integer JHCR_Table_key returns mapsetting
    return ConvertMapSetting(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_mapsetting takes integer JHCR_Table_this,integer JHCR_Table_key,mapsetting JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_mapvisibility takes integer JHCR_Table_this,integer JHCR_Table_key returns mapvisibility
    return ConvertMapVisibility(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_mapvisibility takes integer JHCR_Table_this,integer JHCR_Table_key,mapvisibility JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_pathingtype takes integer JHCR_Table_this,integer JHCR_Table_key returns pathingtype
    return ConvertPathingType(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_pathingtype takes integer JHCR_Table_this,integer JHCR_Table_key,pathingtype JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_placement takes integer JHCR_Table_this,integer JHCR_Table_key returns placement
    return ConvertPlacement(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_placement takes integer JHCR_Table_this,integer JHCR_Table_key,placement JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_playercolor takes integer JHCR_Table_this,integer JHCR_Table_key returns playercolor
    return ConvertPlayerColor(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_playercolor takes integer JHCR_Table_this,integer JHCR_Table_key,playercolor JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_playerevent takes integer JHCR_Table_this,integer JHCR_Table_key returns playerevent
    return ConvertPlayerEvent(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_playerevent takes integer JHCR_Table_this,integer JHCR_Table_key,playerevent JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_playergameresult takes integer JHCR_Table_this,integer JHCR_Table_key returns playergameresult
    return ConvertPlayerGameResult(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_playergameresult takes integer JHCR_Table_this,integer JHCR_Table_key,playergameresult JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_playerscore takes integer JHCR_Table_this,integer JHCR_Table_key returns playerscore
    return ConvertPlayerScore(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_playerscore takes integer JHCR_Table_this,integer JHCR_Table_key,playerscore JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_playerslotstate takes integer JHCR_Table_this,integer JHCR_Table_key returns playerslotstate
    return ConvertPlayerSlotState(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_playerslotstate takes integer JHCR_Table_this,integer JHCR_Table_key,playerslotstate JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_playerstate takes integer JHCR_Table_this,integer JHCR_Table_key returns playerstate
    return ConvertPlayerState(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_playerstate takes integer JHCR_Table_this,integer JHCR_Table_key,playerstate JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_playerunitevent takes integer JHCR_Table_this,integer JHCR_Table_key returns playerunitevent
    return ConvertPlayerUnitEvent(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_playerunitevent takes integer JHCR_Table_this,integer JHCR_Table_key,playerunitevent JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_race takes integer JHCR_Table_this,integer JHCR_Table_key returns race
    return ConvertRace(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_race takes integer JHCR_Table_this,integer JHCR_Table_key,race JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_racepreference takes integer JHCR_Table_this,integer JHCR_Table_key returns racepreference
    return ConvertRacePref(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_racepreference takes integer JHCR_Table_this,integer JHCR_Table_key,racepreference JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_raritycontrol takes integer JHCR_Table_this,integer JHCR_Table_key returns raritycontrol
    return ConvertRarityControl(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_raritycontrol takes integer JHCR_Table_this,integer JHCR_Table_key,raritycontrol JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_soundtype takes integer JHCR_Table_this,integer JHCR_Table_key returns soundtype
    return ConvertSoundType(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_soundtype takes integer JHCR_Table_this,integer JHCR_Table_key,soundtype JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_startlocprio takes integer JHCR_Table_this,integer JHCR_Table_key returns startlocprio
    return ConvertStartLocPrio(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_startlocprio takes integer JHCR_Table_this,integer JHCR_Table_key,startlocprio JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_texmapflags takes integer JHCR_Table_this,integer JHCR_Table_key returns texmapflags
    return ConvertTexMapFlags(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_texmapflags takes integer JHCR_Table_this,integer JHCR_Table_key,texmapflags JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_unitevent takes integer JHCR_Table_this,integer JHCR_Table_key returns unitevent
    return ConvertUnitEvent(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_unitevent takes integer JHCR_Table_this,integer JHCR_Table_key,unitevent JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_unitstate takes integer JHCR_Table_this,integer JHCR_Table_key returns unitstate
    return ConvertUnitState(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_unitstate takes integer JHCR_Table_this,integer JHCR_Table_key,unitstate JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_unittype takes integer JHCR_Table_this,integer JHCR_Table_key returns unittype
    return ConvertUnitType(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_unittype takes integer JHCR_Table_this,integer JHCR_Table_key,unittype JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_version takes integer JHCR_Table_this,integer JHCR_Table_key returns version
    return ConvertVersion(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_version takes integer JHCR_Table_this,integer JHCR_Table_key,version JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_volumegroup takes integer JHCR_Table_this,integer JHCR_Table_key returns volumegroup
    return ConvertVolumeGroup(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_volumegroup takes integer JHCR_Table_this,integer JHCR_Table_key,volumegroup JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_weapontype takes integer JHCR_Table_this,integer JHCR_Table_key returns weapontype
    return ConvertWeaponType(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_weapontype takes integer JHCR_Table_this,integer JHCR_Table_key,weapontype JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction


function JHCR_Table_get_widgetevent takes integer JHCR_Table_this,integer JHCR_Table_key returns widgetevent
    return ConvertWidgetEvent(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_widgetevent takes integer JHCR_Table_this,integer JHCR_Table_key,widgetevent JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction





function JHCR_Table_get_agent takes integer JHCR_Table_this,integer JHCR_Table_key returns agent
    return JHCR_Table_agent[(LoadInteger(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key))]
endfunction
function JHCR_Table_set_agent takes integer JHCR_Table_this,integer JHCR_Table_key,agent JHCR_Table_value returns nothing
    set JHCR_Table_list[JHCR_Table_this] = JHCR_List_cons(JHCR_Table_list[JHCR_Table_this])
    set JHCR_Table_agent[JHCR_Table_list[JHCR_Table_this]]=JHCR_Table_value
    call SaveInteger(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_list[JHCR_Table_this])
endfunction


function JHCR_Table_get_buff takes integer JHCR_Table_this,integer JHCR_Table_key returns buff
    return JHCR_Table_buff[(LoadInteger(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key))]
endfunction
function JHCR_Table_set_buff takes integer JHCR_Table_this,integer JHCR_Table_key,buff JHCR_Table_value returns nothing
    set JHCR_Table_list[JHCR_Table_this] = JHCR_List_cons(JHCR_Table_list[JHCR_Table_this])
    set JHCR_Table_buff[JHCR_Table_list[JHCR_Table_this]]=JHCR_Table_value
    call SaveInteger(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_list[JHCR_Table_this])
endfunction


function JHCR_Table_get_camerasetup takes integer JHCR_Table_this,integer JHCR_Table_key returns camerasetup
    return JHCR_Table_camerasetup[(LoadInteger(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key))]
endfunction
function JHCR_Table_set_camerasetup takes integer JHCR_Table_this,integer JHCR_Table_key,camerasetup JHCR_Table_value returns nothing
    set JHCR_Table_list[JHCR_Table_this] = JHCR_List_cons(JHCR_Table_list[JHCR_Table_this])
    set JHCR_Table_camerasetup[JHCR_Table_list[JHCR_Table_this]]=JHCR_Table_value
    call SaveInteger(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_list[JHCR_Table_this])
endfunction


function JHCR_Table_get_conditionfunc takes integer JHCR_Table_this,integer JHCR_Table_key returns conditionfunc
    return JHCR_Table_conditionfunc[(LoadInteger(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key))]
endfunction
function JHCR_Table_set_conditionfunc takes integer JHCR_Table_this,integer JHCR_Table_key,conditionfunc JHCR_Table_value returns nothing
    set JHCR_Table_list[JHCR_Table_this] = JHCR_List_cons(JHCR_Table_list[JHCR_Table_this])
    set JHCR_Table_conditionfunc[JHCR_Table_list[JHCR_Table_this]]=JHCR_Table_value
    call SaveInteger(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_list[JHCR_Table_this])
endfunction


function JHCR_Table_get_eventid takes integer JHCR_Table_this,integer JHCR_Table_key returns eventid
    return JHCR_Table_eventid[(LoadInteger(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key))]
endfunction
function JHCR_Table_set_eventid takes integer JHCR_Table_this,integer JHCR_Table_key,eventid JHCR_Table_value returns nothing
    set JHCR_Table_list[JHCR_Table_this] = JHCR_List_cons(JHCR_Table_list[JHCR_Table_this])
    set JHCR_Table_eventid[JHCR_Table_list[JHCR_Table_this]]=JHCR_Table_value
    call SaveInteger(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_list[JHCR_Table_this])
endfunction


function JHCR_Table_get_filterfunc takes integer JHCR_Table_this,integer JHCR_Table_key returns filterfunc
    return JHCR_Table_filterfunc[(LoadInteger(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key))]
endfunction
function JHCR_Table_set_filterfunc takes integer JHCR_Table_this,integer JHCR_Table_key,filterfunc JHCR_Table_value returns nothing
    set JHCR_Table_list[JHCR_Table_this] = JHCR_List_cons(JHCR_Table_list[JHCR_Table_this])
    set JHCR_Table_filterfunc[JHCR_Table_list[JHCR_Table_this]]=JHCR_Table_value
    call SaveInteger(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_list[JHCR_Table_this])
endfunction


function JHCR_Table_get_gamecache takes integer JHCR_Table_this,integer JHCR_Table_key returns gamecache
    return JHCR_Table_gamecache[(LoadInteger(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key))]
endfunction
function JHCR_Table_set_gamecache takes integer JHCR_Table_this,integer JHCR_Table_key,gamecache JHCR_Table_value returns nothing
    set JHCR_Table_list[JHCR_Table_this] = JHCR_List_cons(JHCR_Table_list[JHCR_Table_this])
    set JHCR_Table_gamecache[JHCR_Table_list[JHCR_Table_this]]=JHCR_Table_value
    call SaveInteger(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_list[JHCR_Table_this])
endfunction


function JHCR_Table_get_gamestate takes integer JHCR_Table_this,integer JHCR_Table_key returns gamestate
    return JHCR_Table_gamestate[(LoadInteger(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key))]
endfunction
function JHCR_Table_set_gamestate takes integer JHCR_Table_this,integer JHCR_Table_key,gamestate JHCR_Table_value returns nothing
    set JHCR_Table_list[JHCR_Table_this] = JHCR_List_cons(JHCR_Table_list[JHCR_Table_this])
    set JHCR_Table_gamestate[JHCR_Table_list[JHCR_Table_this]]=JHCR_Table_value
    call SaveInteger(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_list[JHCR_Table_this])
endfunction


function JHCR_Table_get_handle takes integer JHCR_Table_this,integer JHCR_Table_key returns handle
    return JHCR_Table_handle[(LoadInteger(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key))]
endfunction
function JHCR_Table_set_handle takes integer JHCR_Table_this,integer JHCR_Table_key,handle JHCR_Table_value returns nothing
    set JHCR_Table_list[JHCR_Table_this] = JHCR_List_cons(JHCR_Table_list[JHCR_Table_this])
    set JHCR_Table_handle[JHCR_Table_list[JHCR_Table_this]]=JHCR_Table_value
    call SaveInteger(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_list[JHCR_Table_this])
endfunction


function JHCR_Table_get_terraindeformation takes integer JHCR_Table_this,integer JHCR_Table_key returns terraindeformation
    return JHCR_Table_terraindeformation[(LoadInteger(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key))]
endfunction
function JHCR_Table_set_terraindeformation takes integer JHCR_Table_this,integer JHCR_Table_key,terraindeformation JHCR_Table_value returns nothing
    set JHCR_Table_list[JHCR_Table_this] = JHCR_List_cons(JHCR_Table_list[JHCR_Table_this])
    set JHCR_Table_terraindeformation[JHCR_Table_list[JHCR_Table_this]]=JHCR_Table_value
    call SaveInteger(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_list[JHCR_Table_this])
endfunction


function JHCR_Table_get_weathereffect takes integer JHCR_Table_this,integer JHCR_Table_key returns weathereffect
    return JHCR_Table_weathereffect[(LoadInteger(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key))]
endfunction
function JHCR_Table_set_weathereffect takes integer JHCR_Table_this,integer JHCR_Table_key,weathereffect JHCR_Table_value returns nothing
    set JHCR_Table_list[JHCR_Table_this] = JHCR_List_cons(JHCR_Table_list[JHCR_Table_this])
    set JHCR_Table_weathereffect[JHCR_Table_list[JHCR_Table_this]]=JHCR_Table_value
    call SaveInteger(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_list[JHCR_Table_this])
endfunction




function JHCR_Table_get_mousebuttontype takes integer JHCR_Table_this,integer JHCR_Table_key returns mousebuttontype
    return ConvertMouseButtonType(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_mousebuttontype takes integer JHCR_Table_this,integer JHCR_Table_key,mousebuttontype JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction






function JHCR_Table_get_animtype takes integer JHCR_Table_this,integer JHCR_Table_key returns animtype
    return ConvertAnimType(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_animtype takes integer JHCR_Table_this,integer JHCR_Table_key,animtype JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction

function JHCR_Table_get_subanimtype takes integer JHCR_Table_this,integer JHCR_Table_key returns subanimtype
    return ConvertSubAnimType(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_subanimtype takes integer JHCR_Table_this,integer JHCR_Table_key,subanimtype JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction







function JHCR_Table_get_framehandle takes integer JHCR_Table_this,integer JHCR_Table_key returns framehandle
    return LoadFrameHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)
endfunction
function JHCR_Table_set_framehandle takes integer JHCR_Table_this,integer JHCR_Table_key,framehandle JHCR_Table_value returns nothing
    call SaveFrameHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_value)
endfunction

function JHCR_Table_get_originframetype takes integer JHCR_Table_this,integer JHCR_Table_key returns originframetype
    return ConvertOriginFrameType(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_originframetype takes integer JHCR_Table_this,integer JHCR_Table_key, originframetype JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction
function JHCR_Table_get_framepointtype takes integer JHCR_Table_this,integer JHCR_Table_key returns framepointtype
    return ConvertFramePointType(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_framepointtype takes integer JHCR_Table_this,integer JHCR_Table_key, framepointtype JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction
function JHCR_Table_get_textaligntype takes integer JHCR_Table_this,integer JHCR_Table_key returns textaligntype
    return ConvertTextAlignType(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_textaligntype takes integer JHCR_Table_this,integer JHCR_Table_key, textaligntype JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction
function JHCR_Table_get_frameeventtype takes integer JHCR_Table_this,integer JHCR_Table_key returns frameeventtype
    return ConvertFrameEventType(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_frameeventtype takes integer JHCR_Table_this,integer JHCR_Table_key, frameeventtype JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction
function JHCR_Table_get_oskeytype takes integer JHCR_Table_this,integer JHCR_Table_key returns oskeytype
    return ConvertOsKeyType(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_oskeytype takes integer JHCR_Table_this,integer JHCR_Table_key, oskeytype JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction
function JHCR_Table_get_abilityintegerfield takes integer JHCR_Table_this,integer JHCR_Table_key returns abilityintegerfield
    return ConvertAbilityIntegerField(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_abilityintegerfield takes integer JHCR_Table_this,integer JHCR_Table_key, abilityintegerfield JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction
function JHCR_Table_get_abilityrealfield takes integer JHCR_Table_this,integer JHCR_Table_key returns abilityrealfield
    return ConvertAbilityRealField(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_abilityrealfield takes integer JHCR_Table_this,integer JHCR_Table_key, abilityrealfield JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction
function JHCR_Table_get_abilitybooleanfield takes integer JHCR_Table_this,integer JHCR_Table_key returns abilitybooleanfield
    return ConvertAbilityBooleanField(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_abilitybooleanfield takes integer JHCR_Table_this,integer JHCR_Table_key, abilitybooleanfield JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction
function JHCR_Table_get_abilitystringfield takes integer JHCR_Table_this,integer JHCR_Table_key returns abilitystringfield
    return ConvertAbilityStringField(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_abilitystringfield takes integer JHCR_Table_this,integer JHCR_Table_key, abilitystringfield JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction
function JHCR_Table_get_abilityintegerlevelfield takes integer JHCR_Table_this,integer JHCR_Table_key returns abilityintegerlevelfield
    return ConvertAbilityIntegerLevelField(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_abilityintegerlevelfield takes integer JHCR_Table_this,integer JHCR_Table_key, abilityintegerlevelfield JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction
function JHCR_Table_get_abilityreallevelfield takes integer JHCR_Table_this,integer JHCR_Table_key returns abilityreallevelfield
    return ConvertAbilityRealLevelField(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_abilityreallevelfield takes integer JHCR_Table_this,integer JHCR_Table_key, abilityreallevelfield JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction
function JHCR_Table_get_abilitybooleanlevelfield takes integer JHCR_Table_this,integer JHCR_Table_key returns abilitybooleanlevelfield
    return ConvertAbilityBooleanLevelField(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_abilitybooleanlevelfield takes integer JHCR_Table_this,integer JHCR_Table_key, abilitybooleanlevelfield JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction
function JHCR_Table_get_abilitystringlevelfield takes integer JHCR_Table_this,integer JHCR_Table_key returns abilitystringlevelfield
    return ConvertAbilityStringLevelField(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_abilitystringlevelfield takes integer JHCR_Table_this,integer JHCR_Table_key, abilitystringlevelfield JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction
function JHCR_Table_get_abilityintegerlevelarrayfield takes integer JHCR_Table_this,integer JHCR_Table_key returns abilityintegerlevelarrayfield
    return ConvertAbilityIntegerLevelArrayField(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_abilityintegerlevelarrayfield takes integer JHCR_Table_this,integer JHCR_Table_key, abilityintegerlevelarrayfield JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction
function JHCR_Table_get_abilityreallevelarrayfield takes integer JHCR_Table_this,integer JHCR_Table_key returns abilityreallevelarrayfield
    return ConvertAbilityRealLevelArrayField(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_abilityreallevelarrayfield takes integer JHCR_Table_this,integer JHCR_Table_key, abilityreallevelarrayfield JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction
function JHCR_Table_get_abilitybooleanlevelarrayfield takes integer JHCR_Table_this,integer JHCR_Table_key returns abilitybooleanlevelarrayfield
    return ConvertAbilityBooleanLevelArrayField(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_abilitybooleanlevelarrayfield takes integer JHCR_Table_this,integer JHCR_Table_key, abilitybooleanlevelarrayfield JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction
function JHCR_Table_get_abilitystringlevelarrayfield takes integer JHCR_Table_this,integer JHCR_Table_key returns abilitystringlevelarrayfield
    return ConvertAbilityStringLevelArrayField(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_abilitystringlevelarrayfield takes integer JHCR_Table_this,integer JHCR_Table_key, abilitystringlevelarrayfield JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction
function JHCR_Table_get_unitintegerfield takes integer JHCR_Table_this,integer JHCR_Table_key returns unitintegerfield
    return ConvertUnitIntegerField(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_unitintegerfield takes integer JHCR_Table_this,integer JHCR_Table_key, unitintegerfield JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction
function JHCR_Table_get_unitrealfield takes integer JHCR_Table_this,integer JHCR_Table_key returns unitrealfield
    return ConvertUnitRealField(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_unitrealfield takes integer JHCR_Table_this,integer JHCR_Table_key, unitrealfield JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction
function JHCR_Table_get_unitbooleanfield takes integer JHCR_Table_this,integer JHCR_Table_key returns unitbooleanfield
    return ConvertUnitBooleanField(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_unitbooleanfield takes integer JHCR_Table_this,integer JHCR_Table_key, unitbooleanfield JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction
function JHCR_Table_get_unitstringfield takes integer JHCR_Table_this,integer JHCR_Table_key returns unitstringfield
    return ConvertUnitStringField(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_unitstringfield takes integer JHCR_Table_this,integer JHCR_Table_key, unitstringfield JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction
function JHCR_Table_get_unitweaponintegerfield takes integer JHCR_Table_this,integer JHCR_Table_key returns unitweaponintegerfield
    return ConvertUnitWeaponIntegerField(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_unitweaponintegerfield takes integer JHCR_Table_this,integer JHCR_Table_key, unitweaponintegerfield JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction
function JHCR_Table_get_unitweaponrealfield takes integer JHCR_Table_this,integer JHCR_Table_key returns unitweaponrealfield
    return ConvertUnitWeaponRealField(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_unitweaponrealfield takes integer JHCR_Table_this,integer JHCR_Table_key, unitweaponrealfield JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction
function JHCR_Table_get_unitweaponbooleanfield takes integer JHCR_Table_this,integer JHCR_Table_key returns unitweaponbooleanfield
    return ConvertUnitWeaponBooleanField(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_unitweaponbooleanfield takes integer JHCR_Table_this,integer JHCR_Table_key, unitweaponbooleanfield JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction
function JHCR_Table_get_unitweaponstringfield takes integer JHCR_Table_this,integer JHCR_Table_key returns unitweaponstringfield
    return ConvertUnitWeaponStringField(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_unitweaponstringfield takes integer JHCR_Table_this,integer JHCR_Table_key, unitweaponstringfield JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction
function JHCR_Table_get_itemintegerfield takes integer JHCR_Table_this,integer JHCR_Table_key returns itemintegerfield
    return ConvertItemIntegerField(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_itemintegerfield takes integer JHCR_Table_this,integer JHCR_Table_key, itemintegerfield JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction
function JHCR_Table_get_itemrealfield takes integer JHCR_Table_this,integer JHCR_Table_key returns itemrealfield
    return ConvertItemRealField(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_itemrealfield takes integer JHCR_Table_this,integer JHCR_Table_key, itemrealfield JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction
function JHCR_Table_get_itembooleanfield takes integer JHCR_Table_this,integer JHCR_Table_key returns itembooleanfield
    return ConvertItemBooleanField(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_itembooleanfield takes integer JHCR_Table_this,integer JHCR_Table_key, itembooleanfield JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction
function JHCR_Table_get_itemstringfield takes integer JHCR_Table_this,integer JHCR_Table_key returns itemstringfield
    return ConvertItemStringField(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_itemstringfield takes integer JHCR_Table_this,integer JHCR_Table_key, itemstringfield JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction
function JHCR_Table_get_movetype takes integer JHCR_Table_this,integer JHCR_Table_key returns movetype
    return ConvertMoveType(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_movetype takes integer JHCR_Table_this,integer JHCR_Table_key, movetype JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction
function JHCR_Table_get_targetflag takes integer JHCR_Table_this,integer JHCR_Table_key returns targetflag
    return ConvertTargetFlag(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_targetflag takes integer JHCR_Table_this,integer JHCR_Table_key, targetflag JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction
function JHCR_Table_get_armortype takes integer JHCR_Table_this,integer JHCR_Table_key returns armortype
    return ConvertArmorType(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_armortype takes integer JHCR_Table_this,integer JHCR_Table_key, armortype JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction
function JHCR_Table_get_heroattribute takes integer JHCR_Table_this,integer JHCR_Table_key returns heroattribute
    return ConvertHeroAttribute(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_heroattribute takes integer JHCR_Table_this,integer JHCR_Table_key, heroattribute JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction
function JHCR_Table_get_defensetype takes integer JHCR_Table_this,integer JHCR_Table_key returns defensetype
    return ConvertDefenseType(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_defensetype takes integer JHCR_Table_this,integer JHCR_Table_key, defensetype JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction
function JHCR_Table_get_regentype takes integer JHCR_Table_this,integer JHCR_Table_key returns regentype
    return ConvertRegenType(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_regentype takes integer JHCR_Table_this,integer JHCR_Table_key, regentype JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction
function JHCR_Table_get_unitcategory takes integer JHCR_Table_this,integer JHCR_Table_key returns unitcategory
    return ConvertUnitCategory(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_unitcategory takes integer JHCR_Table_this,integer JHCR_Table_key, unitcategory JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction
function JHCR_Table_get_pathingflag takes integer JHCR_Table_this,integer JHCR_Table_key returns pathingflag
    return ConvertPathingFlag(GetHandleId(LoadFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key)))
endfunction
function JHCR_Table_set_pathingflag takes integer JHCR_Table_this,integer JHCR_Table_key, pathingflag JHCR_Table_value returns nothing
    call SaveFogStateHandle(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, ConvertFogState(GetHandleId(JHCR_Table_value)))
endfunction






function JHCR_Table_get_minimapicon takes integer JHCR_Table_this,integer JHCR_Table_key returns minimapicon
    return JHCR_Table_minimapicon[(LoadInteger(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key))]
endfunction
function JHCR_Table_set_minimapicon takes integer JHCR_Table_this,integer JHCR_Table_key,minimapicon JHCR_Table_value returns nothing
    set JHCR_Table_list[JHCR_Table_this] = JHCR_List_cons(JHCR_Table_list[JHCR_Table_this])
    set JHCR_Table_minimapicon[JHCR_Table_list[JHCR_Table_this]]=JHCR_Table_value
    call SaveInteger(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_list[JHCR_Table_this])
endfunction

function JHCR_Table_get_commandbuttoneffect takes integer JHCR_Table_this,integer JHCR_Table_key returns commandbuttoneffect
    return JHCR_Table_commandbuttoneffect[(LoadInteger(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key))]
endfunction
function JHCR_Table_set_commandbuttoneffect takes integer JHCR_Table_this,integer JHCR_Table_key,commandbuttoneffect JHCR_Table_value returns nothing
    set JHCR_Table_list[JHCR_Table_this] = JHCR_List_cons(JHCR_Table_list[JHCR_Table_this])
    set JHCR_Table_commandbuttoneffect[JHCR_Table_list[JHCR_Table_this]]=JHCR_Table_value
    call SaveInteger(JHCR_Table_ht, JHCR_Table_this, JHCR_Table_key, JHCR_Table_list[JHCR_Table_this])
endfunction
